/* sc_binary.c
   gopher item subclass procedures for binary files */

     /*---------------------------------------------------------------*/
     /* Xgopher        version 1.3     08 April 1993                  */
     /*                version 1.2     20 November 1992               */
     /*                version 1.1     20 April 1992                  */
     /*                version 1.0     04 March 1992                  */
     /* X window system client for the University of Minnesota        */
     /*                                Internet Gopher System.        */
     /* Allan Tuchman, University of Illinois at Urbana-Champaign     */
     /*                Computing and Communications Services Office   */
     /* Copyright 1992, 1993 by                                       */
     /*           the Board of Trustees of the University of Illinois */
     /* Permission is granted to freely copy and redistribute this    */
     /* software with the copyright notice intact.                    */
     /*---------------------------------------------------------------*/

#include "conf.h"
#include "globals.h"
#include "gopher.h"
#include "util.h"
#include "appres.h"
#include "sc_binary.h"
#include "sc_binaryP.h"



/* GIBinary_init
   initialize binary class - prefix string */

void
GIBinary_init()
{
	GU_makePrefix(prefixBinary,  appResources->prefixBinary);
	GU_registerNewType(A_BINARY, &binarySubclass);

	return;
}


/* GIBinary_access
   check the accessability of a binary file type */

BOOLEAN
GIBinary_access(gi)
gopherItemP	gi;
{
	BOOLEAN	result;

	if (appResources->allowCopy) {
		result = TRUE;
	}else {
		result = FALSE;
	}

	return result;
}
